// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.
//pgrv
//made by @GLshading

#include "fragmentVersionSimple.h"
#include "g_setting.h"
#include "g_noise.h"

#ifdef GL_FRAGMENT_PRECISION_HIGH
#define Hme highp
#else
#define Hme mediump
#endif

#include "uniformShaderConstants.h"
#include "util.h"

LAYOUT_BINDING(0) uniform sampler2D TEXTURE_0;
LAYOUT_BINDING(1) uniform sampler2D TEXTURE_1;

uniform Hme float TOTAL_REAL_WORLD_TIME;
uniform vec4 FOG_COLOR;
uniform vec2 FOG_CONTROL;

varying vec4 color;
varying vec4 col;
varying highp vec3 p;
varying float fog;
varying vec2 lm;
varying highp vec3 cp;

/////STOP/////
//DONT STEAL THIS CODE!!!// 
//made by @GLshading

#define vec4_(d,e) vec4(d,e,e,1)

bool rain_factor(){
if(FOG_CONTROL.x > 0.1 && FOG_CONTROL.x < 0.55){
return true;
}else{
return false;
}}

bool dusk_factor(){
if(FOG_COLOR.r*1.0>FOG_COLOR.b){
return true;
}else{
return false;
}}

bool night_factor(){
if(FOG_COLOR.r<0.15 && FOG_COLOR.g<0.15){
return true;
}else{
return false;
}}

void main(){

//matrials

vec4 gls = col; //trSk
vec4 fc = FOG_COLOR; //trF
Hme float t = TOTAL_REAL_WORLD_TIME;
float wtime = texture2D(TEXTURE_1, vec2(0,1)).r;
float wet_ =smoothstep(0.5,0.3,FOG_CONTROL.x)*float(!(night_factor()));
float night_f=smoothstep(1.,0.2,wtime);
float day_f = smoothstep(0.15,0.2,fc.g);
float dusk_f=min(smoothstep(0.3,0.5,wtime),smoothstep(1.,0.8,wtime))*(1.-wet_)*float(!(night_factor()));

highp float scr =1.-ax(.0,ax(.0,length(cp.xy))-0.55); 
 
//sky col
//best color is "vec4(.14,.2,.26,0.)" //0.2,0.6,0.75,1//vec4(.1,.35,.55,1)//vec4(.04,.3,.6,0.)

vec4 day = mix(mix(vec4(.1,.2,.26,1),vec4(0,.2,.8,1)*1.45,length(p.xz*1.2)*1.25),vec4(0.8,0.9,1.1,1),length(p.xz)*1.2);
vec4 rain = mix(vec4(0.3),vec4(0.2),length(p.xz)*1.3); //sunrise-sunset
vec4 dark = mix(vec4(0.1,0.1,0.1,1.0),vec4(0.,0.1,0.3,1.)*1.2,length(p.xz)*1.5); //night
vec4 dusk = mix(vec4(.1,.2,.36,1.),vec4(2.,1.05,0,1),length(p.xz*0.9)*0.9); //dusk

vec4 skcl=mix(mix(mix(dark,day,day_f),dusk,dusk_f),rain,wet_);

//gls.rgb*=scr;

gls=skcl;

vec2 cloud_pos=(t*0.01+p.xz*8.);
vec2 cloud_pos2=(t*0.01+p.xz*7.3);

float sharp = gcl(cloud_pos,6);
float sharp2 = gcl(cloud_pos2,3);
float sikaku=smoothstep(0.35,0.45,gcl(cloud_pos,6));
float sikaku2=smoothstep(0.35,0.7,gcl(cloud_pos2,3));


vec4 ccolor=mix(mix(mix(vec4(1.6,1.5,1.5,1),vec4(0.75),wet_),vec4(0.4),night_f),vec4(1.4,1.1,0.8,1),dusk_f);
vec4 ccolor2=mix(mix(mix(vec4(0.4,0.35,0.3,1),vec4(0.65),wet_),vec4(0.1),night_f),vec4_(0.3,0.25),dusk_f);

vec4 nightcl=vec4(0.25,0.25,0.4,0.2);vec4 daycl=vec4(0.95,0.95,0.95,1);vec4 raincl=vec4(0.75);vec4 duskcl=vec4(0.5,0.3,0.2,1);
vec4 nightcl2=vec4(0.1);vec4 daycl2=vec4(0.9,0.9,0.9,1);vec4 raincl2=vec4(0.65);vec4 duskcl2=vec4_(0.1,0.15);

vec4 clc=mix(mix(mix(nightcl,daycl,day_f),duskcl,dusk_f),raincl,wet_);
vec4 clc2=mix(mix(mix(nightcl2,daycl2,day_f),duskcl2,dusk_f),raincl2,wet_);
vec4 ccolor4=vec4(0.1,0.7,0.85,0.3);

	#if CLOUD == 1
if(sikaku>0.)clc*=mix(1.1,0.3,sikaku2);
vec4 fragcloud=mix(gls,clc,sikaku);
gls=fragcloud;
	#endif

gl_FragColor = mix(gls,fc,fog);
	//gl_FragColor = vec4(0); //NewdGLS
}