// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

#include "vertexVersionCentroidUV.h"

#include "uniformWorldConstants.h"
#include "uniformPerFrameConstants.h"
#include "uniformShaderConstants.h"
#include "uniformRenderChunkConstants.h"

LAYOUT_BINDING(0) uniform sampler2D TEXTURE_0;
LAYOUT_BINDING(1) uniform sampler2D TEXTURE_1;

attribute POS4 POSITION;
attribute vec2 TEXCOORD_0;
varying highp vec3 wp;
varying vec4 vs;
varying vec3 ps;
varying highp vec2 pw;

uniform highp float TOTAL_REAL_WORLD_TIME;

void main()
{
//vec4 rotate = POSITION;
//rotate.xz *= mat2(cos(t*13.8), -sin(t*13.8), sin(t*13.8), cos(t*13.8));
wp = POSITION.xyz;
//float wtime = texture2D(TEXTURE_1, vec2(0,1)).r;
POS4 s_pos=POSITION;
s_pos.xz*=vec2(15,13);
s_pos.y+=2.;
//s_pos.x-=1.4;

    gl_Position = WORLDVIEWPROJ * s_pos;
    
    vs = POSITION * WORLDVIEWPROJ;
ps = POSITION.xyz;

    uv = TEXCOORD_0;
}