#define off 0 //dont change
#define OFF 0 //dont change
#define on 1 //dont change
#define ON 1 //dont change


/*== Start Customize ==*/

/*--

 Features turn on/off
 
--*/

/*
Enable feature -> on
Disable feature -> off

Dont forget "decimal point"
*/

//-- Water

#define WATER_SURFACE_CAUSTIC off
#define SUN_REFLECTION off //sun reflection when it's sunset or sunrise
#define UNDERWATER_CAUSTIC off //underwater caustic
#define CLOUD_REFLECTION off  //cloud reflection
#define GOD_RAYS off //godrays underwater


//-- waving plant and water and underwater

#define PLANT_WAVES off  //Plants wave
#define UNDERWATER_WAVES on //underwater wave

//-- shadow

#define BLOCK_SHADOW on //block shadow
#define PLANT_SIDE_SHADOW on //plant side shadow

#define shadow_size_start 0.895 //must be start > end
#define shadow_size_end 0.875 //must be start > end

#define shadow_color_R 0.45
#define shadow_color_G 0.45
#define shadow_color_B 0.6

//-- Wet effect

#define PUDDLES off

//-- sky

#define CLOUD off

//-- fog

#define FOGS on
#define CAVE_FOG off

#define day_R 0.85
#define day_G 0.9
#define day_B 1.0

//-- world coloring

#define WORLD_TONE on //world base tone
#define WORLD_COLORING on //color in other than the end

#define World_R 0.82
#define World_G 0.75
#define World_B 0.65

#define sunlight_contrast 4.5 // smaller value is brightness.

//-- Lightning

#define ENABLE_TORCH_LIGHTNING on
#define lightning_strength 0.45 //smaller value is brightness 0.0-1.0

//-- other

#define VIGNETTE on

#define B_GLOWING_ORES on
#define B_SUN_REFLECTION on

/*== End Customize ==*/




/*---------------------------------------*/

/*
DONT ENTER TO BELOW
*/

//-define

#define saturate(x) clamp(x,0.,1.)
#define smt(a,b,c) smoothstep(a,b,c)
#define vec3_(f,g) vec3(f,f,g)
#define ix(a,b,c) mix(a,b,c)
#define ax(a,b) max(a,b)
#define s_r shadow_color_R
#define s_g shadow_color_G
#define s_b shadow_color_B
#define dev_dis 0.5
#define dev_rd 1.0


//--